package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsshipCargoTransferResultMapper;
import com.steerinfo.dil.model.OmsshipShipmentInstructions;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.dil.mapper.AmsshipDeliveryNoticeMapper;
import com.steerinfo.dil.service.IAmsshipDeliveryNoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipDeliveryNotice服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:54
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipDeliveryNotice服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipDeliveryNoticeService")
public class AmsshipDeliveryNoticeServiceImpl implements IAmsshipDeliveryNoticeService {

    @Autowired
    private AmsshipDeliveryNoticeMapper amsshipDeliveryNoticeMapper;
    @Autowired
    private AmsshipCargoTransferResultMapper cargoTransferResultMapper;

    //查询所有数据
    @Override
    public List<Map<String, Object>> selectShipDeliveryNotice(Map<String, Object> mapVal) {
        return amsshipDeliveryNoticeMapper.selectShipDeliveryNotice(mapVal);
    }
    //新增发货通知
    @Override
    public int insert(Map<String,Object> map) {
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        String userId =(String) map.get("userId");
        String userName=null;
        if (userId!=null){
             userName = cargoTransferResultMapper.getUserNameByUserId(userId);
        }
        BigDecimal noticeId = amsshipDeliveryNoticeMapper.selectNoticeId();
        amsshipDeliveryNotice.setNoticeId(noticeId);
        //新增承运商
        if (map.get("carrierId")!=null) {
            amsshipDeliveryNotice.setCarrierId(DataChange.dataToBigDecimal(map.get("carrierId")));
        }
        if (map.get("requesterGroupId")!=null) {
            amsshipDeliveryNotice.setRequesterGroupId(DataChange.dataToBigDecimal(map.get("requesterGroupId")));
        }
        amsshipDeliveryNotice.setNoticeCommerceMethod((String) map.get("noticeCommerceMethod"));
        amsshipDeliveryNotice.setNoticeHandoverMethod((String) map.get("noticeHandoverMethod"));
        if (map.get("portId")!=null) {
            amsshipDeliveryNotice.setPortId(DataChange.dataToBigDecimal(map.get("portId")));
        }

        if (map.get("noticePortConstructionFee")!=null) {
            amsshipDeliveryNotice.setNoticePortConstructionFee(DataChange.dataToBigDecimal(map.get("noticePortConstructionFee")));
        }
        long noticeDeliveryTime =(long) map.get("noticeDeliveryTime");
        amsshipDeliveryNotice.setNoticeDeliveryTime(new Date(noticeDeliveryTime));
        amsshipDeliveryNotice.setNoticePileFreeDays(DataChange.dataToBigDecimal(map.get("noticePileFreeDays")));
        amsshipDeliveryNotice.setNoticeDistributionStatus(new BigDecimal(0));
        if (map.get("batchId")!=null) {
            amsshipDeliveryNotice.setBatchId(DataChange.dataToBigDecimal(map.get("batchId")));
        }
        if (map.get("purchaseContractUnitPrice")!=null) {
            amsshipDeliveryNotice.setPurchaseContractUnitPrice(DataChange.dataToBigDecimal(map.get("purchaseContractUnitPrice")));
        }
        if (map.get("purchaseContractMoisture")!=null) {
            amsshipDeliveryNotice.setPurchaseContractMoisture((String) map.get("purchaseContractMoisture"));
        }
        if (map.get("purchaseContractQualityindex")!=null) {
            amsshipDeliveryNotice.setPurchaseContractUnitPrice(DataChange.dataToBigDecimal(map.get("purchaseContractQualityindex")));
        }
        if (map.get("tfeContent")!=null) {
            amsshipDeliveryNotice.setTfeContent((String) map.get("tfeContent"));
        }
        if (map.get("silicaContent")!=null){
            amsshipDeliveryNotice.setSilicaContent((String)map.get("silicaContent"));
        }
        if (map.get("aluminaContent")!=null){
            amsshipDeliveryNotice.setAluminaContent((String)map.get("aluminaContent"));
        }
        if (map.get("phosphorusContent")!=null){
            amsshipDeliveryNotice.setPhosphorusContent((String)map.get("phosphorusContent"));
        }
        if (map.get("manganeseContent")!=null){
            amsshipDeliveryNotice.setManganeseContent((String)map.get("manganeseContent"));
        }
        amsshipDeliveryNotice.setInsertTime(new Date());
        amsshipDeliveryNotice.setInsertUsername(userName);
        amsshipDeliveryNotice.setDeleted(new BigDecimal(0));
        return amsshipDeliveryNoticeMapper.insertSelective(amsshipDeliveryNotice);
    }

    @Override
    public int sendDeliveryNotice(Map<String, Object> map) {
        BigDecimal noticeId =DataChange.dataToBigDecimal(map.get("noticeId"));
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        amsshipDeliveryNotice.setNoticeId(noticeId);
        amsshipDeliveryNotice.setNoticeDistributionStatus(new BigDecimal(1));
        return amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
    }

    @Override
    public int deleteByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.deleteByPrimaryKey(noticeId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.updateByPrimaryKey(noticeId);
    }


    @Override
    public AmsshipDeliveryNotice selectByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.selectByPrimaryKey(noticeId);
    }

    @Override
    public List<Map<String, Object>> getResultNumber() {
        return amsshipDeliveryNoticeMapper.getResultNumber();
    }
    //货权转移下拉框
    @Override
    public List<Map<String, Object>> getcarrier() {
        return amsshipDeliveryNoticeMapper.getcarrier();
    }
////采购订单号下拉框
//    @Override
//    public List<Map<String, Object>> getOrderNo() {
//        return amsshipDeliveryNoticeMapper.getOrderNo();
//    }

    @Override
    public List<Map<String, Object>> getShipper() {
        return amsshipDeliveryNoticeMapper.getShipper();
    }

    @Override
    public int deleteDeliveryNotice(Map<String, Object> map) {
        AmsshipDeliveryNotice amsshipDeliveryNotice=new AmsshipDeliveryNotice();
        amsshipDeliveryNotice.setNoticeId(DataChange.dataToBigDecimal(map.get("noticeId")));
        amsshipDeliveryNotice.setDeleted(new BigDecimal(1));
        return amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
    }


    @Override
    public List<Map<String, Object>> selectByNoticeId(Integer noticeId) {
        return amsshipDeliveryNoticeMapper.selectByNoticeId(noticeId);
    }


}
